package com.ninegag.android.library.upload

import android.text.TextUtils

import com.under9.android.lib.internal.eventbus.RxBus

class UploadModule private constructor() {

    var config: AbstractUploadModuleConfig? = null
        private set
    var isDebug: Boolean = false

    fun init(config: AbstractUploadModuleConfig, isDebug: Boolean) {
        this.config = config
        this.isDebug = isDebug
    }

    companion object {
        @JvmStatic val instance = UploadModule()

        @JvmStatic fun postEvent(scope: String?, o: Any) {
            if (instance.config!!.shouldFireSysEventWithScope()) {
                // If scope is empty, we can't help, just fire without scope
                if (TextUtils.isEmpty(scope)) {
                    RxBus.getInstance().post(o)
                } else {
                    RxBus.post(scope, o)
                }
            } else {
                RxBus.getInstance().post(o)
            }
        }

        fun registerEventBus(scope: String?, o: Any) {
            if (instance.config!!.shouldFireSysEventWithScope()) {
                requireNotNull(scope) { "You have turned on event scope when firing event, it can't be null" }
                RxBus.register(scope, o)
            } else {
                RxBus.getInstance().register(o)
            }
        }

        fun unregisterEventBus(scope: String?, o: Any) {
            if (instance.config!!.shouldFireSysEventWithScope()) {
                requireNotNull(scope) { "You have turned on event scope when firing event, it can't be null" }
                RxBus.unregister(scope, o)
            } else {
                RxBus.getInstance().unregister(o)
            }
        }
    }
}
