package com.ninegag.android.library.upload

import android.os.Parcelable
import android.view.View
import com.ninegag.android.library.upload.event.DialogPlusDismissEvent
import com.orhanobut.dialogplus.DialogPlus
import com.orhanobut.dialogplus.OnCancelListener
import com.orhanobut.dialogplus.OnClickListener
import com.orhanobut.dialogplus.OnDismissListener

internal class UploadSourceChooserDialogListener(
        private val chooserDialog: UploadSourceChooserDialog
): OnClickListener, OnCancelListener, OnDismissListener {
    var uploadActionCallback: UploadOptionCallback? = null
    var payload: Parcelable? = null
    var uploadTarget: String? = null

    override fun onClick(dialog: DialogPlus?, view: View?) {
        if (view == null) return
        uploadActionCallback?.let { it(view.id) }
        when (view.id) {
            R.id.btn_camera -> chooserDialog.onCameraButtonPressed()
            R.id.btn_gallery -> chooserDialog.onGalleryButtonPressed()
            R.id.btn_custom_camera -> chooserDialog.onCustomCameraButtonPressed()
            R.id.btn_video_link -> chooserDialog.onVideoLinkButtonPressed()
            R.id.btn_article_upload -> chooserDialog.onArticleButtonPressed()
            R.id.btn_add_text -> chooserDialog.onAddTextButtonPressed()
        }
        dialog?.dismiss()
    }

    override fun onCancel(dialog: DialogPlus?) = chooserDialog.onChooserCancelled()

    override fun onDismiss(dialog: DialogPlus?) = UploadModule.postEvent(uploadTarget, DialogPlusDismissEvent())
}