package com.under9.android.comments

import com.google.gson.Gson
import com.google.gson.GsonBuilder
import com.under9.android.comments.model.api.*
import com.under9.android.lib.util.GsonUtil

object GsonFactory {
    // public static final int TYPE_PURE = 1;
    const val TYPE_STANDARD = 2000

    private val provider: GsonUtil.GsonBuilderProvider by lazy {
        object: GsonUtil.GsonBuilderProvider {
            override fun createGsonBuilder(): GsonBuilder {
                val b = GsonBuilder()

                // Comment v2
                b.registerTypeAdapter(ApiCommentList.Payload::class.java, ApiCommentList.ApiCommentList2PayloadDeserializer())
                b.registerTypeAdapter(ApiComment::class.java, ApiComment.ApiComment2Deserializer())

                b.registerTypeAdapter(ApiUser::class.java, ApiUser.ApiUserDeserializer())

                b.registerTypeAdapter(ApiUserStatus.ApiUserStatusPayloadDeserializer::class.java, ApiUserStatus.ApiUserStatusPayloadDeserializer())

                return b
            }
        }
    }

    @JvmStatic
    fun getGson(): Gson {
        return GsonUtil.getGson(TYPE_STANDARD, provider)
    }

    @JvmStatic
    fun <T> fromJson(json: String, classOfT: Class<T>): T? = getGson().fromJson(json, classOfT)
}
