package com.under9.android.comments.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.under9.android.lib.blitz.adapter.BlitzSubAdapter
import com.under9.android.commentsystem.R
import kotlinx.android.synthetic.main.comment_system_hints_item.view.*

class CommentHintsAdapter(private val msgRes: Int) : BlitzSubAdapter<CommentHintsAdapter.HintsViewHolder>() {
    var isShown: Boolean = false
    private set

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): HintsViewHolder {
        return HintsViewHolder(LayoutInflater.from(parent.context).inflate(R.layout.comment_system_hints_item, parent, false))
    }
    override fun onBindViewHolder(vh: HintsViewHolder, i: Int) {
        super.onBindViewHolder(vh, i)
        vh.itemView.textHints.text = vh.itemView.context.getString(msgRes)
    }

    override fun getItemCount() = if(isShown) {
        1
    } else {
        0
    }

    fun show(show: Boolean) {
        if (isShown == show) return

        this.isShown = show

        if (show) {
            notifyItemInserted(0)
        } else {
            notifyItemRemoved(0)
        }
    }

    class HintsViewHolder(itemView: View): BlitzSubAdapter.ViewHolder(itemView)
}