package com.under9.android.comments.ui.renderer

import android.text.TextPaint
import android.text.style.ClickableSpan
import android.view.View
import com.under9.android.comments.model.wrapper.CommentItemWrapperInterface

class UrlClickSpan : ClickableSpan {
    private var commentItemWrapperInterface: CommentItemWrapperInterface? = null
    private var clickListener: OnClickListener? = null
    private val url: String

    internal constructor(commentItemWrapperInterface: CommentItemWrapperInterface,
                         url: String,
                         clickListener: OnClickListener?) {
        this.commentItemWrapperInterface = commentItemWrapperInterface
        this.url= url
        this.clickListener = clickListener
    }

    override fun updateDrawState(ds: TextPaint) {

    }

    override fun onClick(widget: View) {

        commentItemWrapperInterface?.let {
            clickListener?.onClick2(it, this.url)
        }
    }

    interface OnClickListener {
        fun onClick2(commentWrapper: CommentItemWrapperInterface, url: String)
    }
}
