package com.under9.android.comments.ui.widget

import android.content.Context
import android.util.AttributeSet
import android.view.View
import androidx.annotation.AttrRes
import androidx.annotation.StyleRes
import com.under9.android.commentsystem.R
import com.under9.android.lib.widget.uiv.v3.UniversalImageView

class CommentItemView: BaseCommentItemView {
    constructor(context: Context): this(context, null, -1)

    constructor(context: Context, attributeSet: AttributeSet?) : this(context, attributeSet, -1)

    constructor(context: Context, @AttrRes attributeSet: AttributeSet?, @StyleRes defStyleAttr: Int) : super(context, attributeSet, defStyleAttr) {
        attributeSet?.let {
            loadAttributes(context, attributeSet, defStyleAttr)
        }
    }

    lateinit var commentBorder: View

    init {
        layoutId = R.layout.comment_system_list_item_inner_v5
    }

    override fun initView() {
        super.initView()
        commentBorder = findViewById(R.id.commentBorder)
    }
}