package com.under9.android.lib.blitz

sealed class PlaceholderState(open val enabled: Boolean, open val showAsFullscreen: Boolean) {

    data class UninitializedState(override val enabled: Boolean, override val showAsFullscreen: Boolean) : PlaceholderState(enabled, showAsFullscreen)

    data class LoadingState(override val enabled: Boolean, override val showAsFullscreen: Boolean) : PlaceholderState(enabled, showAsFullscreen)

    data class EmptyState(override val enabled: Boolean, override val showAsFullscreen: Boolean) : PlaceholderState(enabled, showAsFullscreen)

    data class ErrorState(override val enabled: Boolean, override val showAsFullscreen: Boolean, val message: String? = null) : PlaceholderState(enabled, showAsFullscreen)

    data class SuccessState(override val enabled: Boolean, override val showAsFullscreen: Boolean): PlaceholderState(enabled, showAsFullscreen)
}
