package com.under9.android.lib.bottomsheet.action

import android.os.Parcelable
import com.under9.android.lib.widget.R
import kotlinx.android.parcel.Parcelize

@Parcelize
data class SelectionBottomSheetModel(
        override val iconRes: Int?,
        override val title: String,
        override val desc: String?,
        override val primaryActionText: String,
        override val secondaryActionText: String? = null,
        override val primaryButtonBgDrawableRes: Int = R.drawable.bg_button_accent_color_round,
        override val secondaryButtonBgDrawableRes: Int = R.drawable.bg_button_normal_color_round,
        override val primaryButtonTextColor: Int = R.color.under9_theme_white,
        override val secondaryButtonTextColor: Int? = null
) : ISelectionSheetModel

@Parcelize
data class ChoiceBottomSheetModel(
        val choices: ArrayList<SelectionChoiceModel>,
        override val iconRes: Int?,
        override val title: String,
        override val desc: String?,
        override val primaryActionText: String,
        override val secondaryActionText: String? = null,
        override val primaryButtonBgDrawableRes: Int = R.drawable.bg_button_accent_color_round,
        override val secondaryButtonBgDrawableRes: Int = R.drawable.bg_button_normal_color_round,
        override val primaryButtonTextColor: Int = R.color.under9_theme_white,
        override val secondaryButtonTextColor: Int?= null
) : ISelectionSheetModel

@Parcelize
data class SelectionChoiceModel(
        val title: String,
        val iconUri: String
) : Parcelable

interface ISelectionSheetModel : Parcelable {
    val iconRes: Int?
    val title: String
    val desc: String?
    val primaryActionText: String
    val secondaryActionText: String?
    val primaryButtonBgDrawableRes: Int
    val secondaryButtonBgDrawableRes: Int
    val primaryButtonTextColor: Int
    val secondaryButtonTextColor: Int?
}