package com.under9.android.lib.bottomsheet.data

import android.os.Parcelable
import androidx.annotation.DrawableRes
import androidx.annotation.IdRes
import com.under9.android.lib.bottomsheet.BottomSheet
import kotlinx.android.parcel.Parcelize

@Parcelize
data class BottomSheetModel(
        val title: String = "",
        val iconString: String? = null,/** Support to create an icon with text */
        @DrawableRes val iconRes: Int = 0,
        @IdRes val id: Int = 0,
        val displayType: Int = 0,
        val iconType: Int = BottomSheet.ICON_TYPE_IMAGE,/** BottomSheet item's icon format, [BottomSheet.ICON_TYPE_IMAGE], [BottomSheet.ICON_TYPE_TEXT_EMOJI] */
        val additionalBooleanInfo: Boolean? = null,
        val additionalStringInfo: String? = null,
        val additionalIconColor: Int = -1,
        val showFeatureLock: Boolean = false,
        val showIndicator: Boolean? = null,
        val additionalIntInfo: Int = -1
) : Parcelable