package com.under9.android.lib.logging

import java.util.HashMap

interface Logger {
    //To log simple messages (count = 1)
    fun log(key: String, category: String, message: String?)

    //To log simple messages (may change the count for stat usage)
    fun log(key: String, count: Int, category: String, message: String?)

    //Log a timed message
    fun log(key: String, category: String, message: String?, totalTime: Long)

    //Start timed log
    fun startTimedLog(key: String, category: String, message: String?)

    //End timed log (the actual logging action should take place at this moment)
    fun endTimedLog(key: String)

    //To log a breadcrumb message (must be in json)
    fun logBreadcrumb(key: String, jsonMessage: String?)

    //To log a breadcrumb message with HashMap data which will be formatted into JSON message automatically
    fun logBreadcrumb(key: String, jsonMessageMap: HashMap<String, Any>?)

    //To log the count only, will replace log(String key, int count, String category, String message); soon
    fun logCount(key: String, count: Int)
}
