package com.under9.android.lib.util

object ArrayUtil {

    fun concatStringArrays(vararg lists: Array<String?>): Array<String?> {
        var l = 0
        val n = lists.size
        for (i in 0 until n) {
            l += lists[i].size
        }
        val result = arrayOfNulls<String>(l)
        var p = 0
        for (i in 0 until n) {
            var j = 0
            val m: Int = lists[i].size
            while (j < m) {
                result[p] = lists[i][j]
                p += 1
                j++
            }
        }
        return result
    }

    /**
     * Slicing [List] to list of sub [List]
     */
    fun <T> chunked(list: List<T>, size: Int): List<List<T>> {
        val subLists = arrayListOf<List<T>>()
        var startingIndex = 0

        while (startingIndex < list.size) {
            val sliceEnding = Math.min(size, size + startingIndex)
            val subList = list.subList(startingIndex, sliceEnding)
            subLists.add(subList)
            startingIndex = sliceEnding
        }

        return subLists
    }

}