package com.under9.android.lib.util

import android.content.ComponentName
import android.content.Context
import android.content.pm.PackageManager
import android.graphics.drawable.Drawable

/**
 * Created by billynyh on 5/26/14.
 */
object PackageUtil {
    fun getIcon(pm: PackageManager, packageName: String?, activityName: String?): Drawable? {
        if (packageName == null) return null
        try {
            return if (activityName == null) {
                pm.getApplicationIcon(packageName)
            } else pm.getActivityIcon(ComponentName(packageName, activityName))
        } catch (e: Exception) {
        }
        return null
    }

    @JvmStatic
    fun getApplicationName(context: Context): String {
        val info = context.applicationInfo
        val id = info.labelRes
        return if (id == 0) info.nonLocalizedLabel.toString() else context.getString(id)
    }
}