package com.under9.android.lib.util

import android.os.Environment
import android.os.StatFs

object StorageUtil {
    // consider full if < 200MB
    @JvmStatic
    fun externalStorageAvailable(): Boolean {
        val externalFree = externalFreeSpace
        val internalFree = internalFreeSpace
        return externalFree > 200 || externalFree > internalFree
    }//in MB

    // in MB
    private val externalFreeSpace: Long
        get() {
            if (Environment.MEDIA_MOUNTED == Environment.getExternalStorageState()) {
                val statFs = StatFs(Environment.getExternalStorageDirectory().path)
                return statFs.availableBlocksLong * statFs.blockSizeLong / 1048576
            }
            return 0
        }

    //in MB
    private val internalFreeSpace: Long
        get() {
            val statFs = StatFs(Environment.getDataDirectory().path)
            return statFs.availableBlocksLong * statFs.blockSizeLong / 1048576
        }

    @JvmStatic fun getFreePhoneSpace(): Long {
        return try {
            val statFs = StatFs(Environment.getDataDirectory().path)
            statFs.availableBlocksLong * statFs.blockSizeLong / 1048576
        } catch (e: Exception) {
            -1
        }
    }

    @JvmStatic fun getFreeSDSpace(): Long {
        return try {
            val statFs = StatFs(Environment.getExternalStorageDirectory().path)
            statFs.availableBlocksLong * statFs.blockSizeLong / 1048576
        } catch (e: Exception) {
            -1
        }
    }
}