package com.under9.android.lib.util.time

import timber.log.Timber
import java.util.*

object DateTimeHelper {

    @JvmStatic
    fun toHHMMSS(seconds: Long): String {
        val second = (seconds % 60).toInt()
        val minute = (seconds / 60 % 60).toInt()
        val hour = (seconds / 3600 % 24).toInt()
        return if (hour > 0) {
            (if (hour < 10) "0$hour" else hour).toString() + ":" + (if (minute < 10) "0$minute" else minute) + ":" + if (second < 10) "0$second" else second
        } else (if (minute < 10) "0$minute" else minute).toString() + ":" + if (second < 10) "0$second" else second
    }

    @JvmStatic
    fun withinToday(timestamp: Long): Boolean {
        val t = Calendar.getInstance()
        t.timeInMillis = timestamp
        return withinToday(t)
    }

    @JvmStatic
    fun withinOneWeek(timestamp: Long): Boolean {
        val t = Calendar.getInstance()
        t.timeInMillis = timestamp
        return withinOneWeek(t)
    }

    @JvmStatic
    fun withinToday(t: Calendar?): Boolean {
        Timber.d("today")
        return CalendarUtil.between(t, CalendarUtil.today(), CalendarUtil.tomorrow())
    }

    @JvmStatic
    fun withinOneWeek(t: Calendar?): Boolean {
        Timber.d("oneWeek")
        val end = CalendarUtil.tomorrow()
        val start = CalendarUtil.tomorrow()
        start.add(Calendar.DAY_OF_MONTH, -7)
        return CalendarUtil.between(t, start, end)
    }
}