package com.under9.android.lib.widget.button

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import com.under9.android.lib.widget.R
import kotlinx.android.synthetic.main.view_loading_button.view.*

class LoadingButton: ConstraintLayout {
    constructor(context: Context?) : super(context) {}
    constructor(context: Context?, attrs: AttributeSet?) : super(context, attrs) {}
    constructor(context: Context?, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {}

    var currentState: State
    set(value) {
        field = value
        when (value) {
            State.Enabled -> {
                buttonBg.isEnabled = true
                progressBar.visibility = View.GONE
                buttonText.visibility = View.VISIBLE
                buttonText.setTextColor(ContextCompat.getColor(context, R.color.under9_theme_white))
            }
            State.Loading -> {
                buttonBg.isEnabled = false
                progressBar.visibility = View.VISIBLE
                buttonText.visibility = View.GONE
            }
            State.Disabled -> {
                buttonBg.isEnabled = false
                progressBar.visibility = View.GONE
                buttonText.visibility = View.VISIBLE
                buttonText.setTextColor(ContextCompat.getColor(context, R.color.under9_normal))
            }
        }
    }

    init {
        LayoutInflater.from(context).inflate(R.layout.view_loading_button, this, true)
        currentState = State.Disabled
    }

    sealed class State{
        object Enabled : State()
        object Loading: State()
        object Disabled: State()
    }
}

