package com.under9.android.lib.widget.radiobutton

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.constraintlayout.widget.ConstraintLayout
import com.under9.android.lib.bottomsheet.action.SelectionChoiceModel
import com.under9.android.lib.util.UiUtil
import com.under9.android.lib.widget.R
import kotlinx.android.synthetic.main.view_selection_radio_button.view.*

class ImageTitleRadioButtonView : ConstraintLayout {
    var isSelectedItem = false
        set(value) {
            field = value
            radioBtn.isChecked = value
        }

    constructor(context: Context) : this(context, null, 0)

    constructor(context: Context, attrSet: AttributeSet?) : this(context, attrSet, 0)

    constructor(context: Context, attrSet: AttributeSet?, defStyleAttr: Int) : super(context, attrSet, defStyleAttr) {
        LayoutInflater.from(context).inflate(R.layout.view_selection_radio_button, this, true)
        layoutParams = LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT)
    }

    fun updateContent(choiceModel: SelectionChoiceModel) {
        icon.setImageURI(choiceModel.iconUri)
        selectTitle.text = choiceModel.title
        selectTitle.setTextColor(UiUtil.themeAttributeToColor(R.attr.under9_themeTextColorPrimary, context, -1))
    }
}